"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var hasFullYear = function (value) { return /^19|^20/.test(value); }; // @todo update this regex in year 2100
var insertHyphen = function (value) { return value.substring(0, 8) + '-' + value.substring(8); };
var prependCentury = function (value) {
    var currentYear = (new Date()).getFullYear() - 2000;
    var year = Number(value.substring(0, 2));
    var century = year <= currentYear ? '20' : '19';
    return century + value;
};
exports.formatSwedishPersonalIdentityNumber = function (value) {
    value = value.replace(/\D/g, '');
    if (value.length < 6)
        return value;
    if (!hasFullYear(value))
        value = prependCentury(value);
    if (value.length < 8)
        return value;
    value = insertHyphen(value);
    return value.substring(0, 13);
};
//# sourceMappingURL=formatter.js.map