"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
exports.createInputFormatter = function (options) { return function (InputComponent) {
    return /** @class */ (function (_super) {
        __extends(InputFormatter, _super);
        function InputFormatter() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.caretPosition = 0;
            _this.setRef = function (inputElement) {
                _this.inputElement = inputElement;
            };
            _this.handleChange = function (event) {
                var value = event.currentTarget.value;
                var isDeleting = /delete\w+$/.test(event.nativeEvent.inputType);
                var selectionEnd = _this.inputElement.selectionEnd || 0;
                if (isDeleting) {
                    _this.caretPosition = selectionEnd;
                    _this.props.onChange(value);
                }
                else {
                    var formatted = options.formatter(value);
                    var delta = formatted.length - value.length;
                    _this.caretPosition = Math.max(selectionEnd + delta, 0);
                    _this.props.onChange(formatted);
                }
            };
            return _this;
        }
        InputFormatter.prototype.shouldComponentUpdate = function (nextProps) {
            if ('value' in nextProps) {
                return nextProps.value !== this.props.value;
            }
            return true;
        };
        InputFormatter.prototype.componentDidUpdate = function () {
            var _this = this;
            setTimeout(function () {
                if (_this.inputElement) {
                    _this.inputElement.setSelectionRange(_this.caretPosition, _this.caretPosition);
                }
            });
        };
        InputFormatter.prototype.render = function () {
            return (React.createElement(InputComponent, __assign({}, this.props, { innerRef: this.setRef, onChange: this.handleChange, maxLength: options.maxLength ? options.maxLength : null })));
        };
        return InputFormatter;
    }(React.Component));
}; };
//# sourceMappingURL=input-formatter.js.map